Bug 3147 - verify_folderlist_xml() leaks memory
Summary: verify_folderlist_xml() leaks memory
Status: VERIFIED FIXED
Alias: None
Product: Claws Mail
Classification: Unclassified
Component: UI/Folder List (show other bugs)
Version: 3.9.3
Hardware: PC Linux
: P3 normal
Assignee: users
URL:
Depends on:
Blocks:
 
Reported: 2014-04-20 11:57 CEST by Deweloper
Modified: 2014-04-27 10:12 CEST (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Deweloper 2014-04-20 11:57:52 CEST
verify_folderlist_xml() calls xml_parse_file(filename).
Shouldn't it call xml_free_tree(node) then? (if node != NULL)

==00:00:40:59.014 2967== 50,398 (20 direct, 50,378 indirect) bytes in 1 blocks are definitely lost in loss record 20,511 of 20,554
==00:00:40:59.014 2967==    at 0x4006B11: malloc (in /usr/lib/valgrind/vgpreload_memcheck-x86-linux.so)
==00:00:40:59.014 2967==    by 0x4806B4B1: g_malloc (gmem.c:104)
==00:00:40:59.014 2967==    by 0x480827E4: g_slice_alloc (gslice.c:1016)
==00:00:40:59.014 2967==    by 0x48082CFD: g_slice_alloc0 (gslice.c:1042)
==00:00:40:59.014 2967==    by 0x4806DEAB: g_node_new (gnode.c:111)
==00:00:40:59.014 2967==    by 0x8256441: xml_build_tree (xml.c:139)
==00:00:40:59.014 2967==    by 0x82564BA: xml_parse_file (xml.c:160)
==00:00:40:59.014 2967==    by 0x80C357A: verify_folderlist_xml (file_checker.c:92)
==00:00:40:59.014 2967==    by 0x80C3738: check_file_integrity (file_checker.c:46)
==00:00:40:59.014 2967==    by 0x80817C5: main (main.c:1281)
Comment 1 users 2014-04-21 10:02:16 CEST
Changes related to this bug have been committed.
Please check latest Git and update the bug accordingly.
You can also get the patch from:
http://git.claws-mail.org/

++ ChangeLog	2014-04-21 10:02:04.033851311 +0200
http://git.claws-mail.org/?p=claws.git;a=commitdiff;h=2588900ab245eec48f5ccc915b29581997038d6a
Merge: e857a07 7445f4f
Author: Colin Leroy <colin@colino.net>
Date:   Mon Apr 21 10:02:03 2014 +0200

    Merge branch 'master' of file:///home/git/claws

http://git.claws-mail.org/?p=claws.git;a=commitdiff;h=7445f4f8674ea0a02e4baff42342b0d9f7754114
Author: Colin Leroy <colin@colino.net>
Date:   Mon Apr 21 10:01:39 2014 +0200

    Fix bug #3150, "etpan_certificate_check() leaks memory"

http://git.claws-mail.org/?p=claws.git;a=commitdiff;h=46063c48ccc0d379e546946563e5047775d62640
Author: Colin Leroy <colin@colino.net>
Date:   Mon Apr 21 10:00:55 2014 +0200

    Fix bug #3148, "Logic error in claws_get_socket_name()"

http://git.claws-mail.org/?p=claws.git;a=commitdiff;h=f933992350613b35e5181fee532f1415e166fefb
Author: Colin Leroy <colin@colino.net>
Date:   Mon Apr 21 10:00:25 2014 +0200

    Fix bug #3147, "verify_folderlist_xml() leaks memory"

http://git.claws-mail.org/?p=claws.git;a=commitdiff;h=e240402b874071ffafe74aaffe60c177cb798567
Author: Colin Leroy <colin@colino.net>
Date:   Mon Apr 21 09:59:11 2014 +0200

    Fix bug #3146, "Memory corruption when deleting a message from folder"
    Reference msginfo before passing to the mark_as_read_timeout deferred
    callback.

http://git.claws-mail.org/?p=claws.git;a=commitdiff;h=f69b3bab9d66372a56e19867f458c3012aefd141
Author: Colin Leroy <colin@colino.net>
Date:   Mon Apr 21 09:57:52 2014 +0200

    Fix bug #3145, "Memory corruption in imap_disconnect_all"
Comment 2 Deweloper 2014-04-27 10:12:48 CEST
Verified using claws-mail a9065aec26499a0e1294c73b6d9e6f039976521e.